java - مشكلة Maven 3 قطعة أثرية




eclipse struts2 (6)

قمت بعمل مشروع دعامات جديد في الكسوف باستخدام بداية struts2-archtype.

بعض الأخطاء حيث في مشروعي بالفعل قبل القيام بأي شيء. حل معظمها ولكن هناك 1 ما زال يعطيني بعض المشاكل.

Missing artifact com.sun:tools:jar:1.5.0:system pom.xml

لقد حاولت إضافة tools.jar إلى مستودع التخزين يدويًا ولكن هذا لم يحل المشكلة.

بلدي بوم يشبه هذا

<?xml version="1.0" encoding="UTF-8" ?>

<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/maven-v4_0_0.xsd">
    <modelVersion>4.0.0</modelVersion>
    <groupId>com.divespot</groupId>
    <artifactId>website</artifactId>
    <packaging>war</packaging>
    <version>0.0.1-SNAPSHOT</version>
    <name>E-Divespot diving community</name>
    <url>http://www.e-divespot.com</url>
    <description>A website to support divers from all around the world.</description>

    <dependencies>
        <!-- Junit -->
        <dependency>
            <groupId>junit</groupId>
            <artifactId>junit</artifactId>
            <version>4.8.2</version>
            <scope>test</scope>
        </dependency>

        <!--  Struts 2 -->
        <dependency>
            <groupId>org.apache.struts</groupId>
            <artifactId>struts2-core</artifactId>
            <version>2.0.11.2</version>
        </dependency>
        <dependency>
            <groupId>org.apache.struts</groupId>
            <artifactId>struts2-sitemesh-plugin</artifactId>
            <version>2.0.11.2</version>
        </dependency>
        <dependency>
            <groupId>org.apache.struts</groupId>
            <artifactId>struts2-spring-plugin</artifactId>
            <version>2.0.11.2</version>
        </dependency>

        <!-- Servlet & Jsp -->
        <dependency>
            <groupId>javax.servlet</groupId>
            <artifactId>servlet-api</artifactId>
            <version>2.4</version>
            <scope>provided</scope>
        </dependency>
        <dependency>
            <groupId>javax.servlet</groupId>
            <artifactId>jsp-api</artifactId>
            <version>2.0</version>
            <scope>provided</scope>
        </dependency>

        <!-- Jakarta Commons -->
        <dependency>
            <groupId>commons-fileupload</groupId>
            <artifactId>commons-fileupload</artifactId>
            <version>1.1.1</version>
        </dependency>

        <!-- Dwr -->
        <dependency>
            <groupId>uk.ltd.getahead</groupId>
            <artifactId>dwr</artifactId>
            <version>1.1-beta-3</version>
        </dependency>
    </dependencies>

    <build>
      <finalName>website</finalName>
        <plugins>
            <plugin>
                <artifactId>maven-compiler-plugin</artifactId>
                <configuration>
                   <source>1.6</source>
                   <target>1.6</target>
                </configuration>
            </plugin>
            <plugin>
                <groupId>org.mortbay.jetty</groupId>
                <artifactId>maven-jetty-plugin</artifactId>
                <version>6.1.5</version>
                <configuration>
                    <scanIntervalSeconds>10</scanIntervalSeconds>
                </configuration>
            </plugin>
        </plugins>
    </build>
</project>

https://code.i-harness.com


sudo-apt-get install openjdk-7-source


المشكلة الرئيسية هي أن المافان لا يمكن أن غرامة tool.jar. لذلك تحدث هذه المشكلة ، ما عليك سوى إضافة ملف tool.jar في مشروعك. أداة Tool.jar موجودة في برنامج java C: \ Program Files \ Java \ jdk1.6.0_14 \ lib
جرب هذا الرمز وآمل أن تقوم بتشغيل بنجاح http://maven.apache.org/xsd/maven-4.0.0.xsd "> 4.0.0 Strust2Testing Strust2Testing 0.0.1-SNAPSHOT war org.apache.struts

        <artifactId>Struts2-core </artifactId>
        <version>2.3.15.1</version>
        <exclusions>
    <exclusion>
        <artifactId>tools</artifactId>
        <groupId>com.sun</groupId>
    </exclusion>
</exclusions>
    </dependency>
</dependencies>
<build>
    <sourceDirectory>src</sourceDirectory>
    <plugins>
        <plugin>
            <artifactId>maven-compiler-plugin</artifactId>
            <version>3.1</version>
            <configuration>
                <source>1.6</source>
                <target>1.6</target>
            </configuration>
        </plugin>
        <plugin>
            <artifactId>maven-war-plugin</artifactId>
            <version>2.3</version>
            <configuration>
                <warSourceDirectory>WebContent</warSourceDirectory>
                <failOnMissingWebXml>false</failOnMissingWebXml>
            </configuration>
        </plugin>
    </plugins>
</build>


بعد أن واجهت نفس المشكلة مؤخرًا ، لم ينجح أي من الحلول المذكورة أعلاه بالنسبة لي. جئت عبر http://blog.samratdhillon.com/archives/598 وأحسب هذا ليكون علة Eclipse المذكورة هناك.

اضطررت إلى حذف كل jre المثبتة من تكوين Eclipse (Window -> Preferences -> Java -> Installed JREs) والاحتفاظ فقط بـ jdk واحد. بعد ذلك عملت مخضرم على ما يرام دون أي تعديل ل eclipse.ini أو أي شيء آخر. هذا هو مع Ecplise Indigo Service Release 1.


تحتاج إلى إضافة إجابة أخرى. بعد ترقية m2e إلى 1.4.20130601-0317 عاد الخطأ مرة أخرى. مرة أخرى ، لم ينجح أي من الحلول المقترحة بما في ذلك الحل الذي اقترحته للتو. في النهاية ، عثرت على الجاني: بما في ذلك org.htmlparser:1.6 كان له اعتماد ضمني على tools.jar . لا فكرة لماذا ساعد حذف jre المثبت مع M2E الأقدم (1.0.something). الآن الحل هو استبعاد tools.jar :

    <dependency>
        <groupId>org.htmlparser</groupId>
        <artifactId>htmlparser</artifactId>
        <version>1.6</version>
        <exclusions>
            <exclusion>
                <artifactId>tools</artifactId>
                <groupId>com.sun</groupId>
            </exclusion>
        </exclusions>
    </dependency>

لا يمكنك استخدام tools.jar من مستودع.

للأسف ، شيء في شجرة التبعية الخاصة بك يعتقد أنه يمكنك. لذا ، يجب عليك استخدام "استثناء" للتخلص من التبعية الحالية ، ثم استبدالها بما يلي.

إذا قمت بإجراء الإصدار الموجود أدناه ، في رسالة الخطأ ، فقد لا تحتاج إلى "يستثني".

انت تحتاج:

  <profiles>
    <profile>
      <id>default-tools.jar</id>
      <activation>
        <property>
          <name>java.vendor</name>
          <value>Sun Microsystems Inc.</value>
        </property>
      </activation>
      <dependencies>
        <dependency>
          <groupId>com.sun</groupId>
          <artifactId>tools</artifactId>
          <version>whatever</version>
          <scope>system</scope>
          <systemPath>${java.home}/../lib/tools.jar</systemPath>
        </dependency>
      </dependencies>
    </profile>


مثال eclipse.ini:

-startup
plugins/org.eclipse.equinox.launcher_1.2.0.v20110502.jar
--launcher.library
plugins/org.eclipse.equinox.launcher.win32.win32.x86_1.1.100.v20110502
-product
org.eclipse.epp.package.java.product
--launcher.defaultAction
openFile
--launcher.XXMaxPermSize
256M
-showsplash
org.eclipse.platform
--launcher.XXMaxPermSize
256m
--launcher.defaultAction
openFile
-vm
C:\Java\JDK\1.6\bin\javaw.exe
-vmargs
-Dosgi.requiredJavaVersion=1.5
-Xms40m
-Xmx1024m

-vm value: Linux مثال:

-vm
/opt/sun-jdk-1.6.0.02/bin/java

من إدخال وصف الرابط هنا







maven-3